import { world, system, Player, ItemStack } from "@minecraft/server";

let itemLog = false;
let items = [];
const dimensions = ["overworld", "nether", "the_end"];

function replaceItems(player) {
if (!player.isValid()) return;
  try {
  const replaceableItems = ["minecraft:torch", "minecraft:soul_torch", "minecraft:lantern", "minecraft:soul_lantern"];
  const customItems = {
    "minecraft:torch": "ptg:torch",
    "minecraft:soul_torch": "ptg:soul_torch",
    "minecraft:lantern": "ptg:lantern",
    "minecraft:soul_lantern": "ptg:soul_lantern"
  };
  
  const inventoryComponent = player.getComponent("minecraft:inventory");
  if (!inventoryComponent) return;
  const inventory = inventoryComponent.container;

  for (let i = 0; i < inventory.size; i++) {
    let itemStack = inventory.getItem(i);
    if (itemStack == undefined) return;
    
    if (itemStack && replaceableItems.includes(itemStack.typeId)) {
      let newItemId = customItems[itemStack.typeId];
      if (newItemId) {
        let newItemStack = new ItemStack(newItemId, itemStack.amount);
        inventory.setItem(i, newItemStack);
      }
    }
  }
} catch (error) {
  console.warn("Error:", error);
  }
}

function glowingEntities() {
dimensions.forEach(d => {
let dims = world.getDimension(d);

let entities = dims.getEntities({excludeTypes: ["minecraft:item", "minecraft:xp_orb"]})
entities.forEach(entity => {
if (entity.isValid()) {
try {
if (entity.getComponent("minecraft:onfire")) {
entity.addTag("onFire")
} else {
entity.removeTag("onFire");
}
} catch {}
}
})
})
}
system.runInterval(() => {
  glowingEntities();
}, 1);

system.runInterval(() => {
  const players = world.getAllPlayers();
  players.forEach(player => {
    if (player.isValid() && player.hasComponent("minecraft:inventory")) {
    replaceItems(player);
    };
  });
});